package com.mysema.rdfbean.owl;

import com.mysema.query.util.*;
import com.mysema.query.types.path.*;

/**
 * QObjectProperty is a Querydsl query type for ObjectProperty
 *
 */
public class QObjectProperty extends PEntity<com.mysema.rdfbean.owl.ObjectProperty>{
    public static final QObjectProperty objectProperty = new QObjectProperty("objectProperty");
    /** basicPropertyFeatures */
    public final PComponentCollection<com.mysema.rdfbean.rdfs.RDFPropertyFeature> basicPropertyFeatures = _simplecol("basicPropertyFeatures",com.mysema.rdfbean.rdfs.RDFPropertyFeature.class);
    /** TransitiveProperty, SymmetricProperty or InverseFunctionalProperty */
    public final PComponentCollection<com.mysema.rdfbean.owl.ObjectPropertyFeature> objectPropertyFeatures = _simplecol("objectPropertyFeatures",com.mysema.rdfbean.owl.ObjectPropertyFeature.class);
    /** domain */
    public final PEntityCollection<com.mysema.rdfbean.rdfs.RDFSClass> domain = _entitycol("domain",com.mysema.rdfbean.rdfs.RDFSClass.class, "RDFSClass");
    /** range */
    public final PEntityCollection<com.mysema.rdfbean.rdfs.RDFSClass> range = _entitycol("range",com.mysema.rdfbean.rdfs.RDFSClass.class, "RDFSClass");
    /** subProperties */
    public final PEntityCollection<com.mysema.rdfbean.rdfs.RDFProperty> subProperties = _entitycol("subProperties",com.mysema.rdfbean.rdfs.RDFProperty.class, "RDFProperty");
    /** subPropertyOf */
    public final PEntityCollection<com.mysema.rdfbean.rdfs.RDFProperty> subPropertyOf = _entitycol("subPropertyOf",com.mysema.rdfbean.rdfs.RDFProperty.class, "RDFProperty");
    /** inverseOf */
    public com.mysema.rdfbean.owl.QObjectProperty inverseOf;
    public com.mysema.rdfbean.owl.QObjectProperty _inverseOf() {
         if (inverseOf == null) inverseOf = new com.mysema.rdfbean.owl.QObjectProperty(PathMetadata.forProperty(this,"inverseOf"));
         return inverseOf;
    }
    
    public QObjectProperty(@NotEmpty String path) {
          this(com.mysema.rdfbean.owl.ObjectProperty.class, path);        
    }
    public QObjectProperty(Class<? extends com.mysema.rdfbean.owl.ObjectProperty> cl, @NotEmpty String path) {
          super(cl, "ObjectProperty", path);
          _inverseOf();
    }    
    public QObjectProperty(PathMetadata<?> metadata) {
         super(com.mysema.rdfbean.owl.ObjectProperty.class, "ObjectProperty", metadata);
    }
}
