package com.mysema.rdfbean.owl;

import com.mysema.query.util.*;
import com.mysema.query.types.path.*;

/**
 * QRestriction is a Querydsl query type for Restriction
 *
 */
public class QRestriction extends PEntity<com.mysema.rdfbean.owl.Restriction>{
    public static final QRestriction restriction = new QRestriction("restriction");
    /** hasValue */
    public final PSimple<java.lang.Object> hasValue = _simple("hasValue",java.lang.Object.class);
    /** cardinality */
    public final PNumber<java.lang.Integer> cardinality = _number("cardinality",java.lang.Integer.class);
    /** maxCardinality */
    public final PNumber<java.lang.Integer> maxCardinality = _number("maxCardinality",java.lang.Integer.class);
    /** minCardinality */
    public final PNumber<java.lang.Integer> minCardinality = _number("minCardinality",java.lang.Integer.class);
    /** complementOf */
    public final PEntityCollection<com.mysema.rdfbean.owl.OWLClass> complementOf = _entitycol("complementOf",com.mysema.rdfbean.owl.OWLClass.class, "OWLClass");
    /** disjointWith */
    public final PEntityCollection<com.mysema.rdfbean.owl.OWLClass> disjointWith = _entitycol("disjointWith",com.mysema.rdfbean.owl.OWLClass.class, "OWLClass");
    /** properties */
    public final PEntityCollection<com.mysema.rdfbean.rdfs.RDFProperty> properties = _entitycol("properties",com.mysema.rdfbean.rdfs.RDFProperty.class, "RDFProperty");
    /** subClasses */
    public final PEntityCollection<com.mysema.rdfbean.rdfs.RDFSClass> subClasses = _entitycol("subClasses",com.mysema.rdfbean.rdfs.RDFSClass.class, "RDFSClass");
    /** superClasses */
    public final PEntityCollection<com.mysema.rdfbean.rdfs.RDFSClass> superClasses = _entitycol("superClasses",com.mysema.rdfbean.rdfs.RDFSClass.class, "RDFSClass");
    /** intersectionOf */
    public final PEntityList<com.mysema.rdfbean.owl.OWLClass> intersectionOf = _entitylist("intersectionOf",com.mysema.rdfbean.owl.OWLClass.class,"OWLClass");
    public com.mysema.rdfbean.owl.QOWLClass intersectionOf(int index) {
        return new com.mysema.rdfbean.owl.QOWLClass(PathMetadata.forListAccess(intersectionOf,index));
    }
    public com.mysema.rdfbean.owl.QOWLClass intersectionOf(com.mysema.query.types.expr.Expr<Integer> index) {
        return new com.mysema.rdfbean.owl.QOWLClass(PathMetadata.forListAccess(intersectionOf,index));
    }
    /** oneOf */
    public final PEntityList<com.mysema.rdfbean.rdfs.RDFSClass> oneOf = _entitylist("oneOf",com.mysema.rdfbean.rdfs.RDFSClass.class,"RDFSClass");
    public com.mysema.rdfbean.rdfs.QRDFSClass oneOf(int index) {
        return new com.mysema.rdfbean.rdfs.QRDFSClass(PathMetadata.forListAccess(oneOf,index));
    }
    public com.mysema.rdfbean.rdfs.QRDFSClass oneOf(com.mysema.query.types.expr.Expr<Integer> index) {
        return new com.mysema.rdfbean.rdfs.QRDFSClass(PathMetadata.forListAccess(oneOf,index));
    }
    /** OWL 2 */
    public final PEntityList<com.mysema.rdfbean.rdfs.RDFProperty> onProperties = _entitylist("onProperties",com.mysema.rdfbean.rdfs.RDFProperty.class,"RDFProperty");
    public com.mysema.rdfbean.rdfs.QRDFProperty onProperties(int index) {
        return new com.mysema.rdfbean.rdfs.QRDFProperty(PathMetadata.forListAccess(onProperties,index));
    }
    public com.mysema.rdfbean.rdfs.QRDFProperty onProperties(com.mysema.query.types.expr.Expr<Integer> index) {
        return new com.mysema.rdfbean.rdfs.QRDFProperty(PathMetadata.forListAccess(onProperties,index));
    }
    /** unionOf */
    public final PEntityList<com.mysema.rdfbean.owl.OWLClass> unionOf = _entitylist("unionOf",com.mysema.rdfbean.owl.OWLClass.class,"OWLClass");
    public com.mysema.rdfbean.owl.QOWLClass unionOf(int index) {
        return new com.mysema.rdfbean.owl.QOWLClass(PathMetadata.forListAccess(unionOf,index));
    }
    public com.mysema.rdfbean.owl.QOWLClass unionOf(com.mysema.query.types.expr.Expr<Integer> index) {
        return new com.mysema.rdfbean.owl.QOWLClass(PathMetadata.forListAccess(unionOf,index));
    }
    /** allValuesFrom */
    public com.mysema.rdfbean.rdfs.QRDFSClass allValuesFrom;
    public com.mysema.rdfbean.rdfs.QRDFSClass _allValuesFrom() {
         if (allValuesFrom == null) allValuesFrom = new com.mysema.rdfbean.rdfs.QRDFSClass(PathMetadata.forProperty(this,"allValuesFrom"));
         return allValuesFrom;
    }
    /** onProperty */
    public com.mysema.rdfbean.rdfs.QRDFProperty onProperty;
    public com.mysema.rdfbean.rdfs.QRDFProperty _onProperty() {
         if (onProperty == null) onProperty = new com.mysema.rdfbean.rdfs.QRDFProperty(PathMetadata.forProperty(this,"onProperty"));
         return onProperty;
    }
    /** someValuesFrom */
    public com.mysema.rdfbean.rdfs.QRDFSClass someValuesFrom;
    public com.mysema.rdfbean.rdfs.QRDFSClass _someValuesFrom() {
         if (someValuesFrom == null) someValuesFrom = new com.mysema.rdfbean.rdfs.QRDFSClass(PathMetadata.forProperty(this,"someValuesFrom"));
         return someValuesFrom;
    }
    
    public QRestriction(@NotEmpty String path) {
          this(com.mysema.rdfbean.owl.Restriction.class, path);        
    }
    public QRestriction(Class<? extends com.mysema.rdfbean.owl.Restriction> cl, @NotEmpty String path) {
          super(cl, "Restriction", path);
          _allValuesFrom();
          _onProperty();
          _someValuesFrom();
    }    
    public QRestriction(PathMetadata<?> metadata) {
         super(com.mysema.rdfbean.owl.Restriction.class, "Restriction", metadata);
    }
}
